<?php if (!defined('phpTodo')) exit();
/* phpTodo - Web based todo lists                                             *}
{* Copyright (C) 2005-07  Jason Frisvold <friz@godshell.com>                  *}
{*                                                                            *}
{* This program is free software; you can redistribute it and/or modify       *}
{* it under the terms of the GNU General Public License as published by       *}
{* the Free Software Foundation; either version 2 of the License, or          *}
{* (at your option) any later version.                                        *}
{*                                                                            *}
{* This program is distributed in the hope that it will be useful,            *}
{* but WITHOUT ANY WARRANTY; without even the implied warranty of             *}
{* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *}
{* GNU General Public License for more details.                               *}
{*                                                                            *}
{* You should have received a copy of the GNU General Public License          *}
{* along with this program; if not, write to the Free Software                *}
{* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

/* $Id: sample_config.php,v 1.26 2007/04/06 18:17:12 xen0phage Exp $ */

// The work directory contains all of the private
// smarty data.  This directory should be below the
// httpd root
$phpTodo_work_dir = '/var/cache/phpTodo';

// The http directory is the first level directory
// where the phpTodo distribution was uncompressed
$phpTodo_http_dir = '/usr/share/phpTodo';

// The smarty directory is the location of the Smarty.class.php file
// F7 Smarty builds are in /usr/share/php/Smarty/
// FC6 and earlier Smarty builds are in /usr/share/Smarty/ instead.
// We will default to F7 but check for a class file in the FC6 location
// You may edit this to a single line pointing to the locaton of your Smarty
// install to save a couple of cycles if you wish.
$phpTodo_smarty_dir = '/usr/share/php/Smarty/';
if (file_exists("/usr/share/Smarty/Smarty.class.php"))
{
	$phpTodo_smarty_dir = "/usr/share/Smarty/";
}

// This is the default stylesheet used by phpTodo
// The location of the stylesheet is relative to
// the http directory
$phpTodo_stylesheet = 'css/default.css';


// The following line **MUST** be removed from the config file
// once the database has been setup and configured.
header("Content-type: text/plain");die("Welcome to phpTodo - Web based todo lists\n\nPlease setup and configure the database and edit the\n/etc/phpTodo/config.php configuration file.\n\nInstructions for setting up the database can be found\nin the /usr/share/doc/phpTodo-0.8.1/INSTALL file.\n\nThe SQL required for setting up the database can be found\nin the /usr/share/doc/phpTodo-0.8.1/sql/ directory.");


// This is the name of the phpTodo database
$phpTodo_dbName = 'phpTodo';

// This is the location of the database server
$phpTodo_dbHost = 'localhost';

// This is the login name for the database
$phpTodo_dbUser = 'phpTodo';

// This is the password for the database
$phpTodo_dbPass = 'password';


// Default session time (in seconds)
$phpTodo_sessTime = 600;

// Default number of records per page to display
// on the overview screen
$phpTodo_rpp = 15;

// The maximum number of RSS feeds a user can create
$phpTodo_max_feeds = 5;

// The maximum number of custom categories a user can create
$phpTodo_max_custom_categories = 5;

// The RSS channel Time To Live (in Minutes)
$phpTodo_channelttl = 15;

// The following are "defaults" for status ids
// These do not normally need to be changed
$phpTodo_notstarted = 1;
$phpTodo_cancelled = 98;
$phpTodo_completed = 99;

/* You should not need to change anything below */

// phpTodo Version
$phpTodo_version = '0.8.1 Beta';

// phpTodo homepage
$phpTodo_homepage = 'http://phptodo.godshell.com';

// Security and user object libraries
require_once('libs/sec_check.php');
require_once('libs/phpTodoUser.php');
require_once('libs/funcs.php');
require_once('libs/classTodoItem.php');

// Force session IDs to be cookie based only
ini_set('session.use_only_cookies', TRUE);

// Disable transparent session IDs (avoid session ID leaking)
ini_set('session.use_trans_sid', FALSE);

// If there is a smarty instance, set the proper variables
if (defined('usesmarty')) {
   // Set up smarty
   include($phpTodo_smarty_dir . 'Smarty.class.php');
   $smarty = new Smarty;

   // Smarty directories
   $smarty->template_dir = "$phpTodo_http_dir/templates";
   $smarty->compile_dir = "$phpTodo_work_dir/templates_c";
   $smarty->cache_dir = "$phpTodo_work_dir/cache";
   $smarty->config_dir = "$phpTodo_work_dir/config";

   // Assign the stylesheet to smarty
   $smarty->assign('stylesheet', $phpTodo_stylesheet);

   // Assign the version number to smarty
   $smarty->assign('phpTodo_version', $phpTodo_version);

   // Assign the homepage to smarty
   $smarty->assign('phpTodo_homepage', $phpTodo_homepage);
}

// Determine the script path
$phpTodo_serverpath = preg_replace('/' . basename($_SERVER['PHP_SELF']) . '/',
                                   '', $_SERVER['PHP_SELF']);
?>
