<?php
/* phpTodo - Web based todo lists                                             *}
{* Copyright (C) 2005-07  Jason Frisvold <friz@godshell.com>                  *}
{*                                                                            *}
{* This program is free software; you can redistribute it and/or modify       *}
{* it under the terms of the GNU General Public License as published by       *}
{* the Free Software Foundation; either version 2 of the License, or          *}
{* (at your option) any later version.                                        *}
{*                                                                            *}
{* This program is distributed in the hope that it will be useful,            *}
{* but WITHOUT ANY WARRANTY; without even the implied warranty of             *}
{* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *}
{* GNU General Public License for more details.                               *}
{*                                                                            *}
{* You should have received a copy of the GNU General Public License          *}
{* along with this program; if not, write to the Free Software                *}
{* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

/* $Id: feed.php,v 1.4 2007/04/06 17:54:16 xen0phage Exp $ */

   // Define phpTodo (to allow access to files)
   define('phpTodo', 1);

   // Load the global config
   require_once('config.php');

   // Load the generator
   require_once('libs/feedcreator.class.php');

   // Set and validate the the request variables
   if (ctype_digit($_REQUEST['user_id'])) {
      $user_id = $_REQUEST['user_id'];
   }
   if (ctype_digit($_REQUEST['feed_id'])) {
      $feed_id = $_REQUEST['feed_id'];
   }
   if (preg_match('/^[a-zA-Z0-9@#$%\^&\*\/]{4,10}\z/', $_REQUEST['secret'])) {
      $secret = $_REQUEST['secret'];
   }

   // Create the feed object;
   $feed = new UniversalFeedCreator();

   // Connect to the database server
   $sqlhdlr = mysql_connect($phpTodo_dbHost, $phpTodo_dbUser, $phpTodo_dbPass)
      or die( 'Error: Database Connect: ' . mysql_error() );

   // Select the database
   mysql_select_db($phpTodo_dbName)
      or die( 'Error: Choose Database: ' . mysql_error() );

   if (! $feed_param = feed_authenticate($user_id, $feed_id, $secret)) {
      // Set up the channel with info indicating an invalid feed
      $feed->title = 'Invalid RSS Feed';

      // bugfix for https and/or non standard ports - Marc Bradshaw <marc@marcbradshaw.co.uk>
      $location = 'http';
      if ( isset($_SERVER['HTTPS'])) { $location .= 's'; }
      $location .= '://'.$_SERVER['SERVER_NAME'];
      if ( isset($_SERVER['HTTPS'])) {
         if ( $_SERVER["SERVER_PORT"] != '443' ) { $location .= ':' . $_SERVER["SERVER_PORT"]; } 
      } else {
         if ( $_SERVER["SERVER_PORT"] != '80' ) { $location .= ':' . $_SERVER["SERVER_PORT"]; } 
      }
      $location .= $phpTodo_serverpath . $_SERVER['REQUEST_URI'];
      $feed->link = $location;

      $feed->description = 'phpTodo Version ' . $phpTodo_version . "\n" .
                        'Auto-generated RSS feed' . "\n" . $phpTodo_homepage;

      // Display the necessary headers
      header('content-type: text/xml');
      header('Content-Disposition: inline; filename=rss_' .
             str_replace(' ', '' ,$feed_param->name . ' - phpTodo RSS Feed.xml'));

      // Display the RSS Feed
      $feeddata = $feed->createFeed($feed_param->version);
      print "$feeddata";

      // Exit
      mysql_close($sqlhdlr);
      exit;
   }

   // Set up the channel
   $feed->title = $feed_param->name . ' - phpTodo RSS Feed';

   // bugfix for https and/or non standard ports - Marc Bradshaw <marc@marcbradshaw.co.uk>
   $location = 'http';
   if ( isset($_SERVER['HTTPS'])) { $location .= 's'; }
   $location .= '://'.$_SERVER['SERVER_NAME'];
   if ( isset($_SERVER['HTTPS'])) {
      if ( $_SERVER["SERVER_PORT"] != '443' ) { $location .= ':' . $_SERVER["SERVER_PORT"]; } 
   } else {
      if ( $_SERVER["SERVER_PORT"] != '80' ) { $location .= ':' . $_SERVER["SERVER_PORT"]; } 
   }
   $location .= $_SERVER['REQUEST_URI'];
   $feed->link = $location;

   $feed->description = 'phpTodo Version ' . $phpTodo_version . "\n" .
                     'Auto-generated RSS feed' . "\n" . $phpTodo_homepage;

   // Get the GMT offset
   $itemTZOffset = date('O');

   // Get all of the todo items from the database
   $query = sprintf('SELECT l.id, l.subject, p.name, d.description, ' .
                    's.status, c.category, DATE_FORMAT(l.start_date, "%s"), ' .
                    'DATE_FORMAT(l.due_date, "%s"), ' .
                    'DATE_FORMAT(l.create_date, "%s"), u.email, u.full_name ' .
                    'FROM listentries AS l LEFT JOIN priority AS p ON p.id = ' .
                    'l.priority_id LEFT JOIN status AS s ON s.id = ' .
                    'l.status_id LEFT JOIN category AS c ON c.id = ' .
                    'l.category_id LEFT JOIN description AS d ON d.list_id = ' .
                    'l.id LEFT JOIN users AS u ON u.id = l.user_id WHERE ' .
                    'l.user_id = %d AND l.status_id != %d', '%m-%d-%Y',
                    '%m-%d-%Y', '%a, %d %b %Y %h:%i:%s', $user_id,
                    $phpTodo_cancelled);

   # If the priority is specified, filter for it
   if ($feed_param->priority != 0) {
      $query = $query . sprintf(' AND l.priority_id = %d',
                                $feed_param->priority);
   }

   # If the status is specified, filter for it
   if ($feed_param->status != 0) {
      $query = $query . sprintf(' AND l.status_id = %d', $feed_param->status);
   }

   # If the category is specified, filter for it
   if ($feed_param->category != 0) {
      $query = $query . sprintf(' AND l.category_id = %d',
                                $feed_param->category);
   }

   # If we don't want to show the completed items, filter them out
   if (($feed_param->show_completed == 0) &&
       ($feed_param->status != $phpTodo_completed)) {
      $query = $query . sprintf(' AND l.status_id != %d', $phpTodo_completed);
   }

   # If specified, filter by the specified field(s)
   if ($feed_param->field_name != '') {
      $query = $query . sprintf(' ORDER BY %s', $feed_param->field_name);
   }

   # If a limit is specified, use it
   if ($feed_param->max_limit != 0) {
      $query = $query . sprintf(' LIMIT %d', $feed_param->max_limit);
   }

   $result = mysql_query($query) or die ( 'Error: Query: ' . mysql_error() );

   # Take the items and place them into the RSS object
   while (list($id, $subject, $priority, $desc, $status, $category, $start_date,
               $due_date, $create_date, $email,
               $user) = mysql_fetch_array($result)) {
      $feedDesc = "Priority : $priority\n";
      $feedDesc .= "Status : $status\n";
      $feedDesc .= "Category : $category\n";

      # Split apart the date and build the way *we* want it
      $date_match = '/^([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})\z/';
      $time_match = '/^[0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})\z/';

      if (isset($start_date) && ($start_date != '00-00-0000')) {
         $feedDesc .= "Start Date : $start_date\n";
      }

      if (isset($due_date) && ($due_date != '00-00-0000')) {
         $feedDesc .= "Due Date : $due_date\n";
      }

      if (get_magic_quotes_gpc()) {
         $feedDesc .= stripslashes(urldecode("$desc"));
         $feedSubject = stripslashes(urldecode($subject));
      } else {
         $feedDesc .= urldecode("$desc");
         $feedSubject = urldecode($subject);
      }

      # Take the data and put it into the rss object
      $item = new FeedItem();
      $item->title = "$feedSubject ($priority)";

      // bugfix for https and/or non standard ports - Marc Bradshaw <marc@marcbradshaw.co.uk>
      $location = 'http';
      if ( isset($_SERVER['HTTPS'])) { $location .= 's'; }
      $location .= '://'.$_SERVER['SERVER_NAME'];
      if ( isset($_SERVER['HTTPS'])) {
         if ( $_SERVER["SERVER_PORT"] != '443' ) { $location .= ':' . $_SERVER["SERVER_PORT"]; } 
      } else {
         if ( $_SERVER["SERVER_PORT"] != '80' ) { $location .= ':' . $_SERVER["SERVER_PORT"]; } 
      }
      $location .= $phpTodo_serverpath ."taskmodify.php?edit=Edit&task_id=$id";
      $item->link = $location;

      $item->description = nl2br("$feedDesc");
      $item->date = "$create_date $itemTZOffset";
      $item->source = '';
      $item->author = "$email ($user)";

      $feed->addItem($item);
  }

   // Free the result
   mysql_free_result($result);

   // Close the MySQL handler
   mysql_close($sqlhdlr);

   // Display the necessary headers
   header('content-type: text/xml');
   header('Content-Disposition: inline; filename=rss_' .
          str_replace(' ', '' ,$feed_param->name . ' - phpTodo RSS Feed.xml'));

   // Display the Feed
   $feeddata = $feed->createFeed($feed_param->version);
   print "$feeddata";
?>
