<?php if (!defined('phpTodo')) exit();
/* phpTodo - Web based todo lists                                             *}
{* Copyright (C) 2005-07  Jason Frisvold <friz@godshell.com>                  *}
{*                                                                            *}
{* This program is free software; you can redistribute it and/or modify       *}
{* it under the terms of the GNU General Public License as published by       *}
{* the Free Software Foundation; either version 2 of the License, or          *}
{* (at your option) any later version.                                        *}
{*                                                                            *}
{* This program is distributed in the hope that it will be useful,            *}
{* but WITHOUT ANY WARRANTY; without even the implied warranty of             *}
{* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *}
{* GNU General Public License for more details.                               *}
{*                                                                            *}
{* You should have received a copy of the GNU General Public License          *}
{* along with this program; if not, write to the Free Software                *}
{* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

/* $Id: sec_check.php,v 1.29 2007/03/06 17:58:04 xen0phage Exp $ */

// Get the browser info and change the content type accordingly
// $browser = get_browser(null, true);
// if ($browser['wap']) {
//    header('Content-Type: text/vnd.wap.wml');
// }

// Start the php session
session_start();

function login($username, $password) {
   // Globalize the phptodo variables needed
   global $phpTodo_sessTime;

   // Create user class
   $user_obj = new phpTodoUser(-1, $username, $password, true);

   if ($user_obj->logged_in()) {
      // Regenerate the session ID (security enhancement)
      session_regenerate_id();

      // Insert the user_id into the sessions database along with the
      // session ID and the current time
      $query = sprintf('INSERT INTO sessions (phpsessid, user_id, last) ' .
                       'VALUES ("%s", "%s", %d)', session_id(),
                       $user_obj->user_id(), time());
      mysql_query($query);

      // Clean up any old sessions that have timed out
      $query = sprintf('DELETE FROM sessions WHERE last < %d', time() - $phpTodo_sessTime);
      mysql_query($query);

      // Return 1 indicating a successful login
      return 1;
   } else {
      // Return 0 indicating a login failure
      return 0;
   }

   // This code should never be executed
   // Return 0 indicating a login failure
   return 0;
}

function authenticate() {
   // Globalize the phptodo variables needed
   global $phpTodo_sessTime, $sqlhdlr;

   // Globalize the user variables
   global $smarty;

   // Try and get the id, last time, and user if from the sessions database
   $query = sprintf('SELECT id, last, user_id FROM sessions WHERE ' .
                    'phpsessid = "%s"', session_id());

   $result = mysql_query($query) or die( 'Error: ' . mysql_error() );

   list($id, $last, $user_id) = mysql_fetch_array($result);

   mysql_free_result($result);

   // Check to see if an id was set, and if the time is good
   if ((isset($id)) && (($last + $phpTodo_sessTime) >= time())) {
      // Good session, update the timestamp
      $query = sprintf("UPDATE sessions SET last = %d WHERE id = %d", time(),
                       $id);
      mysql_query($query);

      // Create the user object
      $user_obj = new phpTodoUser($user_id);

      // Assign the username to the smarty template
      $smarty->assign('username', $user_obj->username());
      $smarty->assign('adminflag', $user_obj->adminflag());
      if (get_magic_quotes_gpc()) {
         $smarty->assign('fullname', stripslashes(htmlentities($user_obj->fullname(), ENT_QUOTES)));
      } else {
         $smarty->assign('fullname', htmlentities($user_obj->fullname(), ENT_QUOTES));
      }

      return($user_obj);
   } else {
      // Return a 0 to indicate that authentication was not successful
      return 0;
   }

   // This code should never be executed
   return 0;
}

function feed_authenticate($user_id, $feed_id, $secret) {
   // Globalize the phptodo variables needed
   global $phpTodo_dbHost, $phpTodo_dbUser, $phpTodo_dbPass, $phpTodo_dbName,
          $phpTodo_sessTime;

   // Get the rss feed information and pass it back to the rss generator
   $query = sprintf('SELECT r.name, r.priority, r.status, r.category, ' .
                    'o.field_name, r.max_limit, r.show_completed, ' .
                    'r.version FROM feeds AS r LEFT JOIN order_by ' .
                    'AS o ON o.id = r.order_by WHERE r.user_id = %d AND r.id ' .
                    '= %d AND r.secret = "%s"', $user_id, $feed_id,
                    mysql_real_escape_string($secret));

   $result = mysql_query($query) or die( 'Error: ' . mysql_error() );

   if (mysql_num_rows($result) == 1) {
      $feed_param = mysql_fetch_object($result);
   
      mysql_free_result($result);

      return $feed_param;
   } else {
      // Return a 0 to indicate that authentication was not successful
      return 0;
   }

   // This code should never be executed
   return 0;
}

function logout() {
   // Try and get the id, last time, and user if from the sessions database
   $query = sprintf("DELETE FROM sessions WHERE phpsessid = '%s'",
                    session_id());

   mysql_query($query) or die( 'Error: ' . mysql_error() );

   return(1);
}

// This function redirects the user to the login page
function login_redirect() {
   foreach ($_REQUEST as $varname => $varvalue) {
      if ($varname != 'PHPSESSID') {
         if (get_magic_quotes_gpc()) {
            $varvalue = stripslashes($varvalue);
         }

         if (isset($redirect)) {
            $redirect .= "&$varname=" . urlencode($varvalue);
         } else {
            $redirect = basename($_SERVER['PHP_SELF']) . "?$varname=" .
                        urlencode($varvalue);
         }
      }
   }


   // bugfix for https and/or non standard ports - Marc Bradshaw <marc@marcbradshaw.co.uk>
   $location = 'http';
   if ( isset($_SERVER['HTTPS'])) { $location .= 's'; }
   $location .= '://'.$_SERVER['HTTP_HOST'];
   if ( isset($_SERVER['HTTPS'])) {
      if ( $_SERVER["SERVER_PORT"] != '443' ) { $location .= ':' . $_SERVER["SERVER_PORT"]; } 
   } else {
      if ( $_SERVER["SERVER_PORT"] != '80' ) { $location .= ':' . $_SERVER["SERVER_PORT"]; } 
   }
   $location .= dirname($_SERVER['PHP_SELF']) . '/';
   $_SESSION['redirect'] = $location;

   if (isset($redirect)) {
       $_SESSION['redirect'] .= $redirect;
   }

   // bugfix for https and/or non standard ports - Marc Bradshaw <marc@marcbradshaw.co.uk>
   $location = 'http';
   if ( isset($_SERVER['HTTPS'])) { $location .= 's'; }
   $location .= '://'.$_SERVER['HTTP_HOST'];
   if ( isset($_SERVER['HTTPS'])) {
      if ( $_SERVER["SERVER_PORT"] != '443' ) { $location .= ':' . $_SERVER["SERVER_PORT"]; } 
   } else {
      if ( $_SERVER["SERVER_PORT"] != '80' ) { $location .= ':' . $_SERVER["SERVER_PORT"]; } 
   }
   $location .= dirname($_SERVER['PHP_SELF']) . '/index.php';
   header('Location: ' . $location);

}

?>
