/* phpTodo - Web based todo lists                                             *}
{* Copyright (C) 2005-07  Jason Frisvold <friz@godshell.com>                  *}
{*                                                                            *}
{* This program is free software; you can redistribute it and/or modify       *}
{* it under the terms of the GNU General Public License as published by       *}
{* the Free Software Foundation; either version 2 of the License, or          *}
{* (at your option) any later version.                                        *}
{*                                                                            *}
{* This program is distributed in the hope that it will be useful,            *}
{* but WITHOUT ANY WARRANTY; without even the implied warranty of             *}
{* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *}
{* GNU General Public License for more details.                               *}
{*                                                                            *}
{* You should have received a copy of the GNU General Public License          *}
{* along with this program; if not, write to the Free Software                *}
{* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

/* $Id: prefs.js,v 1.8 2007/03/07 17:42:56 xen0phage Exp $ */

   /* This function validates the task ids and confirms a delete */
   function deleteFeeds() {
      /* Validate task ids first */
      var id_match = /^\d+$/;
      for (var i = 0; i < document.forms['feeds'].elements['feed_sel[]'].length; i++) {
         /* Only check the id on checked items */
         if (document.forms['feeds'].elements['feed_id[]'][i].checked) {
            if (! id_match.test(document.forms['feeds'].elements['feed_id[]'][i].value)) {
               alert('Invalid feed id');
               return(false);
            }
         }
      }

      /* Then get confirmation on delete */
      return(confirm('Delete selected feed(s)?'));
   }

   /* This function validates the feed info and confirms a save */
   function saveFeeds() {
      var id_match = /^\d+$/;
      var secret_match = /^[a-zA-Z0-9@$%\^&\*\/]{4,15}$/;
      var name_match = /^[a-zA-Z0-9_\-\ ]{1,15}$/;
      var version_match = /^(RSS(0\.91|1\.0|2\.0)|ATOM(0\.3|1\.0))$/;
      for (var i = 0; i < document.forms['feeds'].elements['feed_sel[]'].length; i++) {
         if (! id_match.test(document.forms['feeds'].elements['feed_id[]'][i].value)) {
            alert('Invalid feed id');
            return(false);
         }

         if (! id_match.test(document.forms['feeds'].elements['feed_priority[]'][i].value)) {
            alert('Invalid feed priority');
            return(false);
         }

         if (! id_match.test(document.forms['feeds'].elements['feed_status[]'][i].value)) {
            alert('Invalid feed status');
            return(false);
         }

         if (! id_match.test(document.forms['feeds'].elements['feed_category[]'][i].value)) {
            alert('Invalid feed category');
            return(false);
         }

         if (! id_match.test(document.forms['feeds'].elements['feed_max[]'][i].value)) {
            alert('Invalid feed max');
            return(false);
         }

         if (! id_match.test(document.forms['feeds'].elements['feed_order[]'][i].value)) {
            alert('Invalid feed order');
            return(false);
         }

         if (! name_match.test(document.forms['feeds'].elements['feed_name[]'][i].value)) {
            alert('Invalid feed name');
            return(false);
         }

         if (! secret_match.test(document.forms['feeds'].elements['feed_secret[]'][i].value)) {
            alert('Invalid feed secret');
            return(false);
         }

         if (! version_match.test(document.forms['feeds'].elements['feed_version[]'][i].value)) {
            alert('Invalid feed version');
            return(false);
         }

      }
   }

   function saveuser() {
      var usernameRegex = /^[a-zA-Z0-9_\-]{1,15}$/;
      var fullnameRegex = /^[a-zA-Z0-9_\-\ \']{1,40}$/;
      var emailRegex = /^[a-zA-Z0-9_\-\.!#\$%&\*\+\/=\?\^\{\|\}~]{0,64}@[a-zA-Z0-9\-\.]{0,255}$/;
      var pwdRegex = /^[a-zA-Z0-9@#$%\^&\*\/]{4,15}$/;

      if (! fullnameRegex.test(document.forms.userpref.fullname.value)) {
         alert('Invalid full name.  Full Names can be up to 40 ' +
               'characters using only the following :\na-z A-Z 0-9 _ - \'' +
               'and spaces');
         return(false);
      }

      /* Make sure we're actually looking at passwords */
      if ((document.forms.userpref.old_pass.value == '') &&
          (document.forms.userpref.password.value == '') &&
          (document.forms.userpref.password2.value == '')) {
         return(true);
      }

      if ((! pwdRegex.test(document.forms.userpref.old_pass.value)) ||
          (! pwdRegex.test(document.forms.userpref.password.value))) {
         alert('Invalid password.  Passwords should consist of 4-15 ' +
               'characters using only the following :\na-z A-Z 0-9 @ # ' +
               '$ % ^ & * /');
         return(false);
      }

      if (document.forms.userpref.password.value !==
          document.forms.userpref.password2.value) {
         alert('The new passwords do not match');
         return(false);
      }

      return(true);
   }
