<?php
/* phpTodo - Web based todo lists                                             *}
{* Copyright (C) 2005-07  Jason Frisvold <friz@godshell.com>                  *}
{*                                                                            *}
{* This program is free software; you can redistribute it and/or modify       *}
{* it under the terms of the GNU General Public License as published by       *}
{* the Free Software Foundation; either version 2 of the License, or          *}
{* (at your option) any later version.                                        *}
{*                                                                            *}
{* This program is distributed in the hope that it will be useful,            *}
{* but WITHOUT ANY WARRANTY; without even the implied warranty of             *}
{* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *}
{* GNU General Public License for more details.                               *}
{*                                                                            *}
{* You should have received a copy of the GNU General Public License          *}
{* along with this program; if not, write to the Free Software                *}
{* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

/* $Id: prefs.php,v 1.30 2007/04/06 17:54:16 xen0phage Exp $ */

   // Define phpTodo (to allow access to files)
   define('phpTodo', 1);

   // Define usesmarty (to indicate that config needs to load smarty)
   define('usesmarty', 1);

   // Load the global config
   require_once('config.php');

   // Connect to the database server
   $sqlhdlr = mysql_connect($phpTodo_dbHost, $phpTodo_dbUser, $phpTodo_dbPass)
      or die( 'Error: Database Connect: ' . mysql_error() );

   // Select the database
   mysql_select_db($phpTodo_dbName)
      or die( 'Error: Choose Database: ' . mysql_error() );

   // If the user is not authenticated, jump them to the login page
   if (! $user_obj = authenticate()) {
      login_redirect();
      exit;
   }

   // Assign the user_id to a smarty variable
   $smarty->assign('user_id', $user_obj->user_id());

   // Check for a user preference change and act accordingly
   if (isset($_REQUEST['userpref'])) {
      // If the fullname is set, update accordingly
      if (isset($_REQUEST['fullname'])) {
         if (! $user_obj->fullname($_REQUEST['fullname'])) {
            // If the name doesn't pass validation, pass that info to smarty
            $smarty->assign('badname', 1);
         }
      }

      if ($_REQUEST['old_pass'] != '') { 
         // Make sure all the new passwords were sent and
         // compare the new passwords to ensure they typed it correctly
         if (isset($_REQUEST['password']) && isset($_REQUEST['password2']) &&
             (strcmp($_REQUEST['password'], $_REQUEST['password2']) == 0)) {
            // Check to make sure the old password is correct
            if ($user_obj->check_pwd($_REQUEST['old_pass'])) {
               // Update the database
               if (! $user_obj->password($_REQUEST['password'])) {
                  $smarty->assign('badpwd', 1);
               }
            } else {
               // If the new passwords don't match, report an error
               $smarty->assign('badpwd', 1);
            }
         } else {
            $smarty->assign('badpwd', 1);
         }
      }

      // Assign the fullname to the template, overriding the one assigned
      // by the security module
      $smarty->assign('fullname', htmlentities($_REQUEST['fullname'], ENT_QUOTES));
   }

   // Check to see if we're changing the sort stabilizer
   if (isset($_REQUEST['sort_save'])) {
      $user_obj->sort_stabilizer($_REQUEST['field']);
      $user_obj->sort_order($_REQUEST['order']);
   }

   // Check to see if we're adding a category
   if (isset($_REQUEST['cat_add'])) {
      // Make sure there's room for a new category
      if (count($user_obj->categories()) < $phpTodo_max_custom_categories) {
         if (! $user_obj->categories($_REQUEST['category_name'])) {
            // If the category name is invalid, inform the user
            $smarty->assign('bad_category', 1);
         }
      } else {
         // If there's no room, inform the user
         $smarty->assign('max_categories_set', 1);
      }
   // Check to see if the user is trying to delete a category
   } else if (isset($_REQUEST['cat_del'])) {
      // If so, check to see if there any categories selected
      if (isset($_REQUEST['category_sel'])) {
         // Loop through the categories and mark them for deletion
         foreach ($_REQUEST['category_sel'] as $category_id) {
            $user_obj->categories($category_id, true);
         }
      }
   }

   // Handle any requests dealing with web feeds
   // User is trying to add a new web feed
   if (isset($_REQUEST['feed_add'])) {
      // Get the current number of feeds the user has
      $query = sprintf('SELECT count(*) FROM feeds WHERE user_id = %d',
                       $user_obj->user_id());
      $num_rows = mysql_result(mysql_query($query), 0);

      // Check to make sure the user hasn't exceeded the max number of feeds
      if ($num_rows < $phpTodo_max_feeds) {
         // Add the new feed to the database
         $query = sprintf('INSERT INTO feeds (id, user_id) VALUES (NULL, ' .
                          '%d)', $user_obj->user_id());

         mysql_query($query) or die( 'Error: ' . mysql_error() );
      } else {
         // If the user has hit the max feeds, inform them
         $smarty->assign('max_feeds_set', '1');
      }
   // User is trying to delete a feed
   } else if (isset($_REQUEST['feed_del'])) {
      // Check to make sure the user chose a feed to delete
      if (isset($_REQUEST['feed_sel'])) {
         // Create an array to hold the feeds to be deleted and populate it
         $del_feed = Array();
         foreach ($_REQUEST['feed_sel'] as $feed_id) {
            // Make sure the feed_id sent is a number
            if (ctype_digit($feed_id)) {
               // Add the feed_id to the array
               array_push($del_feed, $feed_id);
            }
         }
         // Delete any items in the array
         $query = sprintf('DELETE FROM feeds WHERE id IN (%s) AND ' .
                          'user_id = %d', implode(',', $del_feed),
                          $user_obj->user_id());
         mysql_query($query) or die( 'Error: ' . mysql_error() );
      }
   // User is trying to save a feed
   } else if (isset($_REQUEST['feed_save'])) {
      // Make sure there is a feed_id set
      if (isset($_REQUEST['feed_id'])) {
         // Regex for secret password
         $phpTodo_secretRegex = '/^[a-zA-Z0-9@$%\^&\*\/]{4,15}\z/';

         // Check eack feed for changes
         foreach (array_keys($_REQUEST['feed_id']) as $array_id) {
            // Validate the feed variables
            if (preg_match('/^[a-zA-Z0-9_\-\ ]{1,15}\z/',
                           $_REQUEST['feed_name'][$array_id]) &&
                preg_match($phpTodo_secretRegex,
                           $_REQUEST['feed_secret'][$array_id]) &&
                ctype_digit($_REQUEST['feed_priority'][$array_id]) &&
                ctype_digit($_REQUEST['feed_status'][$array_id]) &&
                ctype_digit($_REQUEST['feed_category'][$array_id]) &&
                ctype_digit($_REQUEST['feed_order'][$array_id]) &&
                ctype_digit($_REQUEST['feed_max'][$array_id]) &&
                preg_match('/^(RSS(0\.91|1\.0|2\.0)|ATOM(0\.3|1\.0))\z/',
                           $_REQUEST['feed_version'][$array_id]) &&
                ctype_digit($_REQUEST['feed_id'][$array_id])) {
               // Determine if this feed is requesting to show completed items
               if (isset($_REQUEST['feed_show'][$array_id])) {
                  // Show complete items
                  $feed_show = 1;
               } else {
                  // Dont show complete items
                  $feed_show = 0;
               }

               // Update each feed with the settings
               $query = sprintf('UPDATE feeds SET secret = "%s", name = ' .
                                '"%s", priority = %d, status = %d, category ' .
                                '= %d, order_by = %d, max_limit = %d, ' .
                                'show_completed = %d, version = "%s" ' .
                                'WHERE id = %d AND user_id = %d',
                                mysql_real_escape_string($_REQUEST['feed_secret'][$array_id]),
                                mysql_real_escape_string($_REQUEST['feed_name'][$array_id]),
                                $_REQUEST['feed_priority'][$array_id],
                                $_REQUEST['feed_status'][$array_id],
                                $_REQUEST['feed_category'][$array_id],
                                $_REQUEST['feed_order'][$array_id],
                                $_REQUEST['feed_max'][$array_id], $feed_show,
                                $_REQUEST['feed_version'][$array_id],
                                $_REQUEST['feed_id'][$array_id],
                                $user_obj->user_id());
               mysql_query($query) or die( 'Error: ' . mysql_error() );
            } else {
               // If the user has used invalid characters, inform them
               $smarty->assign('badfeed', 1);
            }
         }
      }
   }

   // Create the sort arrays to send to the template
   $sort_type['none'] = "None";
   $sort_type['subject'] = "Subject";
   $sort_type['lastmodified'] = "Last Modified";
   $sort_type['startdate'] = "Start Date";
   $sort_type['duedate'] = "Due Date";
   $sort_type['createdate'] = "Create Date";
   $sort_type['priority'] = "Priority";
   $sort_type['status'] = "Status";
   $sort_type['taskid'] = "Task ID";

   $sort_order['asc'] = "Ascending";
   $sort_order['dsc'] = "Descending";

   $smarty->assign('sort_type', $sort_type);
   $smarty->assign('sort_order', $sort_order);

   $smarty->assign('cur_sort_type', $user_obj->sort_stabilizer());
   $smarty->assign('cur_sort_order', $user_obj->sort_order());

   // Get all of the feed info from the database
   $query = sprintf('SELECT id, secret, name, priority, status, category, ' .
                    'order_by, max_limit, show_completed, version FROM ' .
                    'feeds WHERE user_id = %d', $user_obj->user_id());
   $result = mysql_query($query) or die( 'Error: ' . mysql_error() );

   // Loop through the info and assign it to a multi-dimensional array
   $loop = 0;
   while ($line = mysql_fetch_array($result, MYSQL_NUM)) {
      $feeds[$loop]['feed_id'] = $line[0];
      $feeds[$loop]['feed_secret'] = $line[1];
      $feeds[$loop]['feed_name'] = $line[2];
      $feeds[$loop]['feed_priority'] = $line[3];
      $feeds[$loop]['feed_status'] = $line[4];
      $feeds[$loop]['feed_category'] = $line[5];
      $feeds[$loop]['feed_order'] = $line[6];
      $feeds[$loop]['feed_max'] = $line[7];
      $feeds[$loop]['feed_show'] = $line[8];
      $feeds[$loop]['feed_version'] = $line[9];
      $loop++;
   }

   // If data was returned and there is an array, pass it to the smarty template
   if (isset($feeds)) {
      $smarty->assign('feeds', $feeds);
   }

   // Free the result
   mysql_free_result($result);

   // Assign the necessary template items
   assign_priorities($smarty, true);
   assign_status($smarty, true);
   assign_categories($smarty, $user_obj, true);

   // Create the array for order_list and assign
   $query = 'SELECT id, pretty_name FROM order_by ORDER BY id';

   $result = mysql_query($query) or die ( 'Error: Query: ' . mysql_error() );

   while ($line = mysql_fetch_array($result)) {
      $order_list[$line[0]] = $line[1];
   }

   $smarty->assign('order_list', $order_list);

   // Free the result
   mysql_free_result($result);

   // Assign the editable categories
   $smarty->assign('category_edit', $user_obj->categories());

   // Create the array for the Max_feeds and assign
   $max_list = array(0 => 'All',
                     5 => 5,
                     10 => 10,
                     15 => 15,
                     25 => 25,
                     50 => 50);

   $smarty->assign('max_list', $max_list);

   // Create the array for feed version and assign
   $feed_version = array('RSS0.91' => 'RSS 0.91',
                         'RSS1.0'  => 'RSS 1.0',
                         'RSS2.0'  => 'RSS 2.0',
                         'ATOM0.3'  => 'ATOM 0.3',
                         'ATOM1.0'  => 'ATOM 1.0');

   $smarty->assign('feed_version_list', $feed_version);

   // Close the user object
   $user_obj->finish();

   // Close the MySQL handler
   mysql_close($sqlhdlr);

   // Display the template
   $smarty->display('prefs.tpl');
?>
