/* phpTodo - Web based todo lists                                             *}
{* Copyright (C) 2005-07  Jason Frisvold <friz@godshell.com>                  *}
{*                                                                            *}
{* This program is free software; you can redistribute it and/or modify       *}
{* it under the terms of the GNU General Public License as published by       *}
{* the Free Software Foundation; either version 2 of the License, or          *}
{* (at your option) any later version.                                        *}
{*                                                                            *}
{* This program is distributed in the hope that it will be useful,            *}
{* but WITHOUT ANY WARRANTY; without even the implied warranty of             *}
{* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *}
{* GNU General Public License for more details.                               *}
{*                                                                            *}
{* You should have received a copy of the GNU General Public License          *}
{* along with this program; if not, write to the Free Software                *}
{* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

/* $Id: taskedit.js,v 1.11 2007/03/06 17:58:03 xen0phage Exp $ */

   var entry_dirty = false;

   /* This function checks the data before allowing the form to submit */
   function tasksave() {
      /* Validate data first */
      var id_match = /^\d+$/;
      var date_match = /^[0-9]{1,2}-[0-9]{1,2}-[0-9]{4}$/;
      var date_time_match = /^[0-9]{1,2}-[0-9]{1,2}-[0-9]{4} [0-9]{1,2}:[0-9]{1,2}:[0-9]{1,2}$/;
      if (! id_match.test(document.forms.task.priority_id.value)) {
         alert('Invalid Priority');
         return(false);
      }
      if (! id_match.test(document.forms.task.status_id.value)) {
         alert('Invalid Status');
         return(false);
      }
      if (! id_match.test(document.forms.task.category_id.value)) {
         alert('Invalid Category');
         return(false);
      }
      if (document.forms.task.due_date.value.length > 0) {
         if (! date_match.test(document.forms.task.due_date.value)) {
            if (! date_time_match.test(document.forms.task.due_date.value)) {
               alert('Invalid Date');
               return(false);
            }
         }
      }
      if (document.forms.task.start_date.value.length > 0) {
         if (! date_match.test(document.forms.task.start_date.value)) {
            if (! date_time_match.test(document.forms.task.start_date.value)) {
               alert('Invalid Date');
               return(false);
            }
         }
      }
      if (document.forms.task.subject.value.length == 0) {
         alert('Please enter a subject');
         return(false);
      }
      if (document.forms.task.subject.value.length > 75) {
         alert('Subject is too long');
         return(false);
      }
   }

   /* Verify that you want to cancel */
   function taskcancel() {
      if (entry_dirty) {
         return(confirm("You have made changes, are you sure you want to lose these changes?"));
      } else {
         return(true);
      }
   }

   /* This function deletes a task from the task list */
   function taskdelete() {
      /* Validate taskid */
      var match_id = /^\d+$/;
      if (match_id.test(document.forms.task.task_id.value)) {
         return(confirm("Are you sure you want to delete this task?"));
      } else {
         alert("Task ID was not numeric!");
         return(false);
      }
   }

   /* This function copies the data from the next action field */
   /* And appends it to the description field */
   function copynclear() {
      var oldaction = document.forms.task.nextaction.value;

      if (oldaction.length > 0) {
         /* Copy the old Next Action data to the description field */
         document.forms.task.description.value = 
            document.forms.task.description.value + "\n" + oldaction;

         /* Clear the Next Action field */
         document.forms.task.nextaction.value = '';
      }
   }

   function mark_change() {
      entry_dirty = true;
   }
