<?php
/* phpTodo - Web based todo lists                                             *}
{* Copyright (C) 2005-07  Jason Frisvold <friz@godshell.com>                  *}
{*                                                                            *}
{* This program is free software; you can redistribute it and/or modify       *}
{* it under the terms of the GNU General Public License as published by       *}
{* the Free Software Foundation; either version 2 of the License, or          *}
{* (at your option) any later version.                                        *}
{*                                                                            *}
{* This program is distributed in the hope that it will be useful,            *}
{* but WITHOUT ANY WARRANTY; without even the implied warranty of             *}
{* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *}
{* GNU General Public License for more details.                               *}
{*                                                                            *}
{* You should have received a copy of the GNU General Public License          *}
{* along with this program; if not, write to the Free Software                *}
{* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

/* $Id: taskmodify.php,v 1.31 2007/03/07 17:42:56 xen0phage Exp $ */

   // Define phpTodo (to allow access to files)
   define('phpTodo', 1);

   // Define usesmarty (to indicate that config needs to load smarty)
   define('usesmarty', 1);

   // Load the global config
   require_once('config.php');

   // Connect to the database server
   $sqlhdlr = mysql_connect($phpTodo_dbHost, $phpTodo_dbUser, $phpTodo_dbPass)
      or die( 'Error: Database Connect: ' . mysql_error() );

   // Select the database
   mysql_select_db($phpTodo_dbName)
      or die( 'Error: Choose Database: ' . mysql_error() );

   // If the user is not authenticated, jump them to the main page
   if (! $user_obj = authenticate()) {
      login_redirect();
      exit;
   }

   // Check for a page number and assign to the template
   if (is_numeric($_REQUEST['page_num'])) {
      $smarty->assign('page_num', $_REQUEST['page_num']);
   } else {
      $smarty->assign('page_num', 1);
   }

   // Check to see if this is a cancel
   if (isset($_REQUEST['cancel'])) {
      // Redirect to the main page
      $smarty->assign('redirect', true);

      // Display the template
      $smarty->display('taskmodify.tpl');
   // Check for edit and full add
   } elseif (isset($_REQUEST['edit']) || isset($_REQUEST['fulladd'])) {
      // Assign the necessary template items
      assign_priorities($smarty);
      assign_status($smarty);
      assign_categories($smarty, $user_obj);

      // Check to see if this is a request to edit a task
      // If so, we just get the info from the DB and populate the form
      if (isset($_REQUEST['edit'])) {
         // Create the Todo Item
         $todo_item = new TodoItem($user_obj, $_REQUEST['task_id']);

         // Assign the variables to the smarty template
         $smarty->assign('task_id', $todo_item->task_id());
         $smarty->assign('priority_id', $todo_item->priority_id());
         $smarty->assign('status_id', $todo_item->status_id());
         $smarty->assign('category_id', $todo_item->category_id());
         $smarty->assign('due_date', $todo_item->due_date());
         $smarty->assign('start_date', $todo_item->start_date());
         $smarty->assign('description',
                         htmlentities($todo_item->description()));
         $smarty->assign('nextaction',
                         htmlentities($todo_item->nextaction()));
         $smarty->assign('subject',
                         htmlentities($todo_item->subject(), ENT_QUOTES));
         $smarty->assign('complete_date', $todo_item->complete_date());
         $smarty->assign('edit', true);

      // Otherwise, this is a full add request and we need to populate the form
      // using the variables from the request
      } elseif (isset($_REQUEST['fulladd'])) {
         // Create the Todo Item
         $todo_item = new TodoItem($user_obj);

         // Populate the todo item
         if (isset($_REQUEST['priority_id']))
            $todo_item->priority_id($_REQUEST['priority_id']);
         if (isset($_REQUEST['status_id']))
            $todo_item->status_id($_REQUEST['status_id']);
         if (isset($_REQUEST['category_id']))
            $todo_item->category_id($_REQUEST['category_id']);
         if (isset($_REQUEST['subject']))
            $todo_item->subject($_REQUEST['subject']);
         if (isset($_REQUEST['due_date']))
            $todo_item->due_date($_REQUEST['due_date']);

         $smarty->assign('priority_id', $todo_item->priority_id());
         $smarty->assign('status_id', $todo_item->status_id());
         $smarty->assign('category_id', $todo_item->category_id());
         $smarty->assign('subject', 
                         htmlentities($todo_item->subject(), ENT_QUOTES));
         $smarty->assign('due_date', $todo_item->due_date());
      }

      // Display the template
      $smarty->display('taskedit.tpl');
   // If not an edit, then this must be a save or delete
   } else {
      if (isset($_REQUEST['task_id'])) {
         $todo_item = new TodoItem($user_obj, $_REQUEST['task_id']);
      } else {
         $todo_item = new TodoItem($user_obj);
      }

      // Populate the todo item
      if (isset($_REQUEST['priority_id']))
         $todo_item->priority_id($_REQUEST['priority_id']);
      if (isset($_REQUEST['status_id']))
         $todo_item->status_id($_REQUEST['status_id']);
      if (isset($_REQUEST['category_id']))
         $todo_item->category_id($_REQUEST['category_id']);
      if (isset($_REQUEST['subject']))
         $todo_item->subject($_REQUEST['subject']);
      if (isset($_REQUEST['due_date']))
         $todo_item->due_date($_REQUEST['due_date']);
      if (isset($_REQUEST['description']))
         $todo_item->description($_REQUEST['description']);
      if (isset($_REQUEST['nextaction']))
         $todo_item->nextaction($_REQUEST['nextaction']);
      if (isset($_REQUEST['due_date']))
         $todo_item->due_date($_REQUEST['due_date']);
      if (isset($_REQUEST['start_date']))
         $todo_item->start_date($_REQUEST['start_date']);

      // Check to see if this is a request to mark a task complete
      if (isset($_REQUEST['complete']))
         $todo_item->status_id($phpTodo_completed);

      // Check to see if we're deleting thie request
      if (isset($_REQUEST['delete']))
         $todo_item->delete();

      // Close out the todo item
      $todo_item->finish();

      // Redirect to the main page
      $smarty->assign('redirect', true);

      // Display the template
      $smarty->display('taskmodify.tpl');
   }

   // Close the MySQL handler
   mysql_close($sqlhdlr);

?>
