{* phpTodo - Web based todo lists                                             *}
{* Copyright (C) 2005-06  Jason Frisvold <friz@godshell.com>                  *}
{*                                                                            *}
{* This program is free software; you can redistribute it and/or modify       *}
{* it under the terms of the GNU General Public License as published by       *}
{* the Free Software Foundation; either version 2 of the License, or          *}
{* (at your option) any later version.                                        *}
{*                                                                            *}
{* This program is distributed in the hope that it will be useful,            *}
{* but WITHOUT ANY WARRANTY; without even the implied warranty of             *}
{* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *}
{* GNU General Public License for more details.                               *}
{*                                                                            *}
{* You should have received a copy of the GNU General Public License          *}
{* along with this program; if not, write to the Free Software                *}
{* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA *}

{* $Id: prefs.tpl,v 1.28 2007/03/07 17:42:57 xen0phage Exp $ *}

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
   <head>
      <meta http-equiv='content-type' content='text/html; charset=ISO-8859-1' />
      <script type="text/javascript" src="prefs.js"></script>
      <link rel='stylesheet' href='{$stylesheet}' type='text/css' />
      <title>phpTodo</title>
   </head>
   <body>
      {assign var=page value='prefs'}
      {include file='header.tpl'}
      <div>
         <div class='centered'>
            <h3>User Preferences</h3>
         </div>
         <form id='userpref' method='post' action=''>
            <div class='centered'>
               <span class='small'>Full Name :</span>
               <input type='text' name='fullname' size='25' maxlength='50' value='{$fullname}' />
               <br />
               <span class='small'>Old Password :</span>
               <input type='password' name='old_pass' size='25' maxlength='50' />
               <br />
               <span class='small'>New Password :</span>
               <input type='password' name='password' size='25' maxlength='50' />
               <br />
               <span class='small'>Confirm New Password :</span>
               <input type='password' name='password2' size='25' maxlength='50' />
               <p class='note'>NOTE : Passwords should be 4-15 characters long and may contain any of the following :
               <br />a-z A-Z 0-9 @ # $ % ^ &amp; * /</p>
               <input type='submit' name='userpref' value='Save Changes' onclick='return saveuser();' />
            </div>
         </form>
         {if $badname == 1}
            <h3 class='alert'>Unable to change Full Name, invalid characters in name</h3>
         {/if}
         {if $badpwd == 1}
            <h3 class='alert'>ERROR : Unable to change password</h3>
         {/if}
         <br />
         <form id='sort' method='post' action='prefs.php'>
            <div class='centered'>
               <p>
                  Sort Stabilizer : 
                  <select name='field'>
                     {html_options options=$sort_type selected=$cur_sort_type}
                  </select>
                  <select name='order'>
                     {html_options options=$sort_order selected=$cur_sort_order}
                  </select>
                  <input type='submit' name='sort_save' value='Save' />
               </p>
            </div>
         </form>
      </div>
      <hr class='onethird' />
      <div>
         <h3>Web Feeds</h3>
         <form id='feeds' method='post' action='prefs.php'>
            <div class='centered'>
               <table>
                  <thead>
                     <tr class='header'>
                        <th>&nbsp;</th>
                        <th>Version</th>
                        <th>Feed Name</th>
                        <th>Secret</th>
                        <th>Priority</th>
                        <th>Status</th>
                        <th>Category</th>
                        <th>Order By</th>
                        <th>Limit</th>
                        <th>Show Completed</th>
                     </tr>
                  </thead>
                  <tbody>
                     {foreach from=$feeds item=row}
                     <tr class='{cycle values="odd,even"}'>
                        <td>
                           <a href='feed.php?user_id={$user_id}&amp;secret={$row.feed_secret}&amp;feed_id={$row.feed_id}'>
                           {if ($row.feed_version == 'ATOM0.3') || ($row.feed_version == 'ATOM1.0')}
                              <img src='images/atom-icon.gif' alt='ATOM Feed' />
                           {else}
                              <img src='images/rss.gif' alt='RSS Feed' />
                           {/if}
                           </a>
                           &nbsp;
                           <input type='checkbox' name='feed_sel[]' value='{$row.feed_id}' />
                           <input type='hidden' name='feed_id[]' value='{$row.feed_id}' />
                        </td><td>
                           <select name='feed_version[]'>
                              {html_options options=$feed_version_list selected=$row.feed_version}
                           </select>
                        </td><td>
                           <input type='text' name='feed_name[]' size='15' maxlength='15' value='{$row.feed_name}' />
                        </td><td>
                           <input type='text' name='feed_secret[]' size='15' maxlength='15' value='{$row.feed_secret}' />
                        </td><td>
                           <select name='feed_priority[]'>
                              {html_options options=$priority_list selected=$row.feed_priority}
                           </select>
                        </td><td>
                           <select name='feed_status[]'>
                              {html_options options=$status_list selected=$row.feed_status}
                           </select>
                        </td><td>
                           <select name='feed_category[]'>
                              {html_options options=$category_list selected=$row.feed_category}
                           </select>
                        </td><td>
                           <select name='feed_order[]'>
                              {html_options options=$order_list selected=$row.feed_order}
                           </select>
                        </td><td>
                           <select name='feed_max[]'>
                              {html_options options=$max_list selected=$row.feed_max}
                           </select>
                        </td><td>
                           {if $row.feed_show == 1}
                           <input type='checkbox' name='feed_show[]' checked />
                           {else}
                           <input type='checkbox' name='feed_show[]' />
                           {/if}
                        </td>
                     </tr>
                     {/foreach}
                  </tbody>
               </table>
               <br />
               <input type='submit' name='feed_add' value='Add New' />
               &nbsp;&nbsp;
               <input type='submit' name='feed_del' value='Delete Feed' onclick='return deleteFeeds();' />
               &nbsp;&nbsp;
               <input type='submit' name='feed_save' value='Save Feeds' onclick='return saveFeeds();' />
            </div>
         </form>
         {if $badfeed == 1}
            <h3 class='alert'>Unable to save feed, Invalid Characters</h3>
         {/if}
         {if $max_feeds_set == 1}
            <h3 class='alert'>Unable to create feed, Max Feeds reached</h3>
         {/if}
         <p style='text-align: center;'>
            <a href="http://feedvalidator.org">
               <img src="images/valid-rss.png" alt="Feed Validator" title="Validate my RSS feed" />
               <img src="images/valid-atom.png" alt="Feed Validator" title="Validate my ATOM feed" />
            </a>
         </p>
      </div>
      <hr class='onethird' />
      <div>
         <h3>Custom Categories</h3>
         <form id='categories' method='post' action='prefs.php'>
            <div class='centered'>
               <table>
                  <thead>
                     <tr class='header'>
                        <th>Delete?</th>
                        <th>Category</th>
                     </tr>
                  </thead>
                  <tbody>
                     {foreach from=$category_edit item=row key=id}
                     <tr class='{cycle values="odd,even"}'>
                        <td>
                           <input type='checkbox' name='category_sel[]' value='{$id}' />
                           <input type='hidden' name='category_id[]' value='{$id}' />
                        </td>
                        <td>{$row}</td>
                     </tr>
                     {/foreach}
                  </tbody>
               </table>
               <br />
               <input type='text' name='category_name' />
               &nbsp;&nbsp;
               <input type='submit' name='cat_add' value='Add' />
               &nbsp;&nbsp;
               <input type='submit' name='cat_del' value='Delete' />
            </div>
         </form>
         {if $max_categories_set == 1}
            <h3 class='alert'>Unable to create category, Max Categories reached</h3>
         {/if}
         {if $bad_category == 1}
            <h3 class='alert'>Unable to create category, Bad Category Name</h3>
         {/if}
      </div>
      {include file='footer.tpl'}
   </body>
</html>
