{* phpTodo - Web based todo lists                                             *}
{* Copyright (C) 2005-07  Jason Frisvold <friz@godshell.com>                  *}
{*                                                                            *}
{* This program is free software; you can redistribute it and/or modify       *}
{* it under the terms of the GNU General Public License as published by       *}
{* the Free Software Foundation; either version 2 of the License, or          *}
{* (at your option) any later version.                                        *}
{*                                                                            *}
{* This program is distributed in the hope that it will be useful,            *}
{* but WITHOUT ANY WARRANTY; without even the implied warranty of             *}
{* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *}
{* GNU General Public License for more details.                               *}
{*                                                                            *}
{* You should have received a copy of the GNU General Public License          *}
{* along with this program; if not, write to the Free Software                *}
{* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA *}

{* $Id: todolist.tpl,v 1.35 2007/03/06 17:58:05 xen0phage Exp $ *}

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
   <head>
      <meta http-equiv='content-type' content='text/html; charset=ISO-8859-1' />
      <link rel='stylesheet' href='{$stylesheet}' type='text/css' />
      <script type="text/javascript" src="todolist.js"></script>
      <script type="text/javascript" src="datetimepicker.js">
         // Date Time Picker script- by TengYong Ng of http://www.rainforestnet.com
         // Script featured on JavaScript Kit (http://www.javascriptkit.com)
         // For this script, visit http://www.javascriptkit.com
      </script>
      <title>phpTodo</title>
   </head>
   <body>
      {assign var=page value='main'}
      {include file='header.tpl'}
      <div class='tasklist'>
         <form id='sorter' action='todolist.php' method='post'>
            <table width='75%'>
               <tbody>
                  <tr>
                     <th style='width:10%'>Priority
                        <input type='hidden' name='sort_column' value='' />
                        <img src='images/{$priority_sort}.png' alt='{$priority_sort}' onclick='change_sort("priority");' />
                     </th>
                     <th style='width:10%'>Status
                        <img src='images/{$status_sort}.png' alt='{$status_sort}' onclick='change_sort("status");' />
                     </th>
                     <th style='width:60%'>Subject
                        <img src='images/{$subject_sort}.png' alt='{$subject_sort}' onclick='change_sort("subject");' />
                     </th>
                     <th style='width:10%'>Due Date
                        <img src='images/{$duedate_sort}.png' alt='{$duedate_sort}' onclick='change_sort("duedate");' />
                     </th>
                     <th style='width:10%'>Action</th>
                  </tr>
                  {foreach from=$todolist item=row}
                  {cycle values="odd,even" assign=rowcolor}
                  <tr class='{$rowcolor}'>
                     <td>{$row.priority}</td>
                     <td>{$row.status}</td>
                     {if $row.nextaction}
                     <td><a href='#' class='nextaction'>{$row.subject}<span>{$row.nextaction}</span></a></td>
                     {else}
                     <td>{$row.subject}</td>
                     {/if}
                     {if $row.period == 'current'}
                     <td>{$row.due_date}</td>
                     {elseif $row.period == 'overdue'}
                     <td class='overdue'>{$row.due_date}</td>
                     {elseif $row.period == 'today'}
                     <td class='today'>{$row.due_date}</td>
                     {/if}
                     <td>
                        <a href='taskmodify.php?edit=edit&amp;task_id={$row.id}&amp;page_num={$linkCur}' onclick='return editTask({$row.id});'>E</a>
                        <a href='taskmodify.php?complete=complete&amp;task_id={$row.id}&amp;page_num={$linkCur}' onclick='return completeTask({$row.id});'>C</a>
                     </td>
                  </tr>
                  {/foreach}
                  <tr>
                     <td colspan='2' style='text-align: left;'>
                        {if $show_completed == 0}
                        <input type='checkbox' name='show_completed' onclick='change_sort("completed");' />
                        {else}
                        <input type='checkbox' name='show_completed' onclick='change_sort("completed");' checked />
                        {/if}
                        Show Cancelled/Completed
                     </td><td>
                        Category
                        <select name='category' onchange='change_sort("category");'>
                           {html_options options=$category_sort selected=$category_val}
                        </select>
                     </td>
                     {* PAGINATOR *}
                     <td class='navigate' colspan='2'>
                        <span class='small'>
                        {if $linkNum > 1}
                           {if $linkCur == $linkFirst}
                              &lt;=
                           {else}
                              <a href='?page_num={$linkFirst}'>&lt;=</a>
                           {/if}
                           {if $linkPrev}
                              <a href='?page_num={$linkPrev}'>&lt;</a>
                           {else}
                              &lt;
                           {/if}
                           {foreach from=$linkArray item=link}
                              {if $link == $linkCur}
                                 {$link}
                              {else}
                                 <a href='?page_num={$link}'>{$link}</a>
                              {/if}
                           {/foreach}
                           {if $linkNext}
                              <a href='?page_num={$linkNext}'>&gt;</a>
                           {else}
                              &gt;
                           {/if}
                           {if $linkLast == 0}
                              =&gt;
                           {else}
                              <a href='?page_num={$linkLast}'>=&gt;</a>
                           {/if}
                        {else}
                           &lt;= &lt; 1 &gt; =&gt;
                        {/if}
                        </span>
                     </td>
                     {* /PAGINATOR *}
                  </tr>
               </tbody>
            </table>
         </form>
      </div>
      <div class='taskform'>
         <form id='task' method='post' action='taskmodify.php'>
            <table class='naked'>
               <tbody>
                  <tr>
                     <td>Priority</td>
                     <td>Status</td>
                     <td>Category</td>
                     <td>Subject</td>
                     <td>Due Date</td>
                  </tr><tr>
                     <td>
                        <select name='priority_id'>
                           {html_options options=$priority_list}
                        </select>
                     </td><td>
                        <select name='status_id'>
                           {html_options options=$status_list}
                        </select>
                     </td><td>
                        <select name='category_id'>
                           {html_options options=$category_list selected=$category_val}
                        </select>
                     </td><td>
                        <input name='subject' size='75' maxlength='75' />
                     </td><td>
                        <input id='duedate' name='due_date' size='10' />
                        <img src="images/cal.gif" width="16" height="16" alt="Pick a date" onclick='NewCal("duedate","mmddyyyy" )' />
                     </td>
                  </tr><tr>
                     <td colspan='4'>
                        <input type='hidden' name='page_num' value='{$linkCur}' />
                        <input type='submit' name='quickadd' value='Quick Add' onclick='return validateAdd();' />
                        &nbsp;&nbsp;
                        <input type='submit' name='fulladd' value='Add' onclick='return validateAdd();' />
                     </td>
                  </tr>
               </tbody>
            </table>
         </form>
      </div>
      {include file='footer.tpl'}
   </body>
</html>
