{* phpTodo - Web based todo lists                                             *}
{* Copyright (C) 2005-07  Jason Frisvold <friz@godshell.com>                  *}
{*                                                                            *}
{* This program is free software; you can redistribute it and/or modify       *}
{* it under the terms of the GNU General Public License as published by       *}
{* the Free Software Foundation; either version 2 of the License, or          *}
{* (at your option) any later version.                                        *}
{*                                                                            *}
{* This program is distributed in the hope that it will be useful,            *}
{* but WITHOUT ANY WARRANTY; without even the implied warranty of             *}
{* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *}
{* GNU General Public License for more details.                               *}
{*                                                                            *}
{* You should have received a copy of the GNU General Public License          *}
{* along with this program; if not, write to the Free Software                *}
{* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA *}

{* $Id: users.tpl,v 1.9 2007/03/06 17:58:05 xen0phage Exp $ *}

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
   <head>
      <meta http-equiv='content-type' content='text/html; charset=ISO-8859-1' />
      <script type="text/javascript" src="users.js"></script>
      <link rel='stylesheet' href='{$stylesheet}' type='text/css' />
      <title>phpTodo</title>
   </head>
   <body>
      {assign var=page value='users'}
      {include file='header.tpl'}
      <div>
         <h3>User Management</h3>
         <div class='centered'>
            <table>
               <thead>
                  <tr class='header'>
                     <th>User Name</th>
                     <th>Full Name</th>
                     <th>Email Address</th>
                     <th>Action</th>
                  </tr>
               </thead>
               <tbody>
                  {foreach from=$userlist item=row}
                  {cycle values="odd,even" assign=rowcolor}
                  <tr class='{$rowcolor}'>
                     <td>{$row.username}</td>
                     <td>{$row.fullname}</td>
                     <td>{$row.email}</td>
                     <td>
                        <a href='users.php?edit=edit&amp;userid={$row.userid}' class='{$rowcolor}'>E</a>
                        <a href='users.php?delete=delete&amp;userid={$row.userid}' class='{$rowcolor}'>D</a>
                     </td>
                  </tr>
                  {/foreach}
                  {* PAGINATOR *}
                  <tr>
                     <td class='navigate' colspan='3'>
                        <span class='small'>
                        {if $linkNum > 1}
                           {if $linkCur == $linkFirst}
                              &lt;=
                           {else}
                              <a href='?page_num={$linkFirst}'>&lt;=</a>
                           {/if}
                           {if $linkPrev}
                              <a href='?page_num={$linkPrev}'>&lt;</a>
                           {else}
                              &lt;
                           {/if}
                           {foreach from=$linkArray item=link}
                              {if $link == $linkCur}
                                 {$link}
                              {else}
                                 <a href='?page_num={$link}'>{$link}</a>
                              {/if}
                           {/foreach}
                           {if $linkNext}
                              <a href='?page_num={$linkNext}'>&gt;</a>
                           {else}
                              &gt;
                           {/if}
                           {if $linkLast == 0}
                              =&gt;
                           {else}
                              <a href='?page_num={$linkLast}'>=&gt;</a>
                           {/if}
                        {else}
                           &lt;= &lt; 1 &gt; =&gt;
                        {/if}
                        </span>
                     </td>
                  </tr>
                  {* /PAGINATOR *}
                  </tbody>
            </table>
         </div>
         <br /><br />
         <div>
            <form id='usermod' action='users.php' method='post'>
               <table>
                  <thead>
                     <tr>
                        <th>UserName</th>
                        <th>Full Name</th>
                        <th>Email Address</th>
                        <th>Password</th>
                     </tr>
                  </thead>
                  <tbody>
                     <tr>
                        <td>
                           <input name='username' size='15' maxlength='15' value='{$edit_username}' />
                        </td><td>
                           <input name='fullname' size='40' maxlength='40' value='{$edit_fullname}' />
                        </td><td>
                           <input name='email' size='30' maxlength='320' value='{$edit_email}' />
                        </td><td>
                           <input type='password' name='password' size='15' maxlength='15' />
                           <input name='userid' type='hidden' value='{$edit_userid}' />
                        </td>
                     </tr>
                  </tbody>
               </table>
               <div class='centered'>
                  <br />
                  {if $edituser}
                  <input type='hidden' name='edit' value='edit' />
                  <input name='save' type='submit' value='Save Changes' onclick='return saveuser();' />
                  {else}
                  <input type='hidden' name='add' value='add' />
                  <input name='save' type='submit' value='Add User' onclick='return saveuser();' />
                  {/if}
                  <p class='note'>NOTE : Passwords should be 4-15 characters long and may contain any of the following :
                  <br />a-z A-Z 0-9 @ # $ % ^ &amp; * /</p>
               </div>
            </form>
            {if $badentry == 1}
               <h3 class='alert'>Invalid Password</h3>
            {/if}
            {if $badentry == 2}
               <h3 class='alert'>Invalid Full Name</h3>
            {/if}
            {if $badentry == 3}
               <h3 class='alert'>Invalid Username</h3>
            {/if}
            {if $badentry == 4}
               <h3 class='alert'>Invalid Email</h3>
            {/if}
         </div>
      </div>
      {include file='footer.tpl'}
   </body>
</html>
