<?php
/* phpTodo - Web based todo lists                                             *}
{* Copyright (C) 2005-07  Jason Frisvold <friz@godshell.com>                  *}
{*                                                                            *}
{* This program is free software; you can redistribute it and/or modify       *}
{* it under the terms of the GNU General Public License as published by       *}
{* the Free Software Foundation; either version 2 of the License, or          *}
{* (at your option) any later version.                                        *}
{*                                                                            *}
{* This program is distributed in the hope that it will be useful,            *}
{* but WITHOUT ANY WARRANTY; without even the implied warranty of             *}
{* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *}
{* GNU General Public License for more details.                               *}
{*                                                                            *}
{* You should have received a copy of the GNU General Public License          *}
{* along with this program; if not, write to the Free Software                *}
{* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

/* $Id: todolist.php,v 1.31 2007/04/06 17:54:16 xen0phage Exp $ */

   // Define phpTodo (to allow access to files)
   define('phpTodo', 1);

   // Define usesmarty (to indicate that config needs to load smarty)
   define('usesmarty', 1);

   // Load the global config
   require_once('config.php');

   // Connect to the database server
   $sqlhdlr = mysql_connect($phpTodo_dbHost, $phpTodo_dbUser, $phpTodo_dbPass)
      or die( '<p>Unable to connect to the database server at this time: ' .
              mysql_error() . ' </p>' );

   // Select the database
   mysql_select_db($phpTodo_dbName)
      or die( '<p>Unable to locate the database at this time: ' .
              mysql_error() . ' </p>' );

   // If the user is not authenticated, jump them to the home page
   if (! $user_obj = authenticate()) {
      login_redirect();
      exit;
   }

   // Load the paginator class
   include('libs/paginator.php');

   // User Preferences - Set and Store
   if (isset($_REQUEST['sort_column']) || isset($_REQUEST['category']) ||
      isset($_REQUEST['show_completed'])) {

      # Check the sort_column value and act accordingly
      if (preg_match('/^priority\z/', $_REQUEST['sort_column'])) {
         $priority = $user_obj->priority_sort();
         if ($priority == 2) {
            $user_obj->priority_sort(0);
         } else {
            $user_obj->priority_sort(++$priority);
         }

         // We're sorting by priority, set the others to 0
         $user_obj->status_sort(0);
         $user_obj->subject_sort(0);
         $user_obj->duedate_sort(0);
      } else if (preg_match('/^status\z/', $_REQUEST['sort_column'])) {
         $status = $user_obj->status_sort();
         if ($status == 2) {
            $user_obj->status_sort(0);
         } else {
            $user_obj->status_sort(++$status);
         }

         // We're sorting by status, set the others to 0
         $user_obj->priority_sort(0);
         $user_obj->subject_sort(0);
         $user_obj->duedate_sort(0);
      } else if (preg_match('/^subject\z/', $_REQUEST['sort_column'])) {
         $subject = $user_obj->subject_sort();
         if ($subject == 2) {
            $user_obj->subject_sort(0);
         } else {
            $user_obj->subject_sort(++$subject);
         }

         // We're sorting by subject, set the others to 0
         $user_obj->priority_sort(0);
         $user_obj->status_sort(0);
         $user_obj->duedate_sort(0);
      } else if (preg_match('/^duedate\z/', $_REQUEST['sort_column'])) {
         $duedate = $user_obj->duedate_sort();
         if ($duedate == 2) {
            $user_obj->duedate_sort(0);
         } else {
            $user_obj->duedate_sort(++$duedate);
         }

         // We're sorting by duedate, set the others to 0
         $user_obj->priority_sort(0);
         $user_obj->status_sort(0);
         $user_obj->subject_sort(0);
      }

      if (ctype_digit($_REQUEST['category'])) {
         $user_obj->category_filter($_REQUEST['category']);
      }

      # Set the show_complete variable based on the form submission
      if (isset($_REQUEST['show_completed'])) {
         $user_obj->show_complete(true);
      } else {
         $user_obj->show_complete(false);
      }
   }

   // Check priority_sort
   switch ($user_obj->priority_sort()) {
      case 0:
         $smarty->assign('priority_sort', 'sort_none');
         break;
      case 1:
         $smarty->assign('priority_sort', 'sort_ascending');
         break;
      case 2:
         $smarty->assign('priority_sort', 'sort_descending');
         break;
   }

   // Check status_sort
   switch ($user_obj->status_sort()) {
      case 0:
         $smarty->assign('status_sort', 'sort_none');
         break;
      case 1:
         $smarty->assign('status_sort', 'sort_ascending');
         break;
      case 2:
         $smarty->assign('status_sort', 'sort_descending');
         break;
   }

   // Check subject_sort
   switch ($user_obj->subject_sort()) {
      case 0:
         $smarty->assign('subject_sort', 'sort_none');
         break;
      case 1:
         $smarty->assign('subject_sort', 'sort_ascending');
         break;
      case 2:
         $smarty->assign('subject_sort', 'sort_descending');
         break;
   }

   // Check duedate_sort
   switch ($user_obj->duedate_sort()) {
      case 0:
         $smarty->assign('duedate_sort', 'sort_none');
         break;
      case 1:
         $smarty->assign('duedate_sort', 'sort_ascending');
         break;
      case 2:
         $smarty->assign('duedate_sort', 'sort_descending');
         break;
   }

   $smarty->assign('show_completed', $user_obj->show_complete());
   $smarty->assign('priority_val', $user_obj->priority_sort());
   $smarty->assign('status_val', $user_obj->status_sort());
   $smarty->assign('subject_val', $user_obj->subject_sort());
   $smarty->assign('duedate_val', $user_obj->duedate_sort());
   $smarty->assign('category_val', $user_obj->category_filter());

   // Query to retrieve the list entries
   $query_head = 'SELECT count(*) ';
   $query_tail = sprintf('FROM listentries AS l LEFT JOIN description AS d ' .
                         'ON d.list_id = l.id, priority AS p, status AS s ' .
                         'WHERE l.status_id = s.id AND l.priority_id = p.id ' .
                         'AND l.user_id = %d', $user_obj->user_id());

   // Ignore completed/cancelled entries if the user doesn't want to see them
   if (! $user_obj->show_complete()) {
      $query_tail = $query_tail . sprintf(' AND l.status_id NOT IN (%d,%d)',
                    $phpTodo_completed, $phpTodo_cancelled);
   }

   // Filter categories
   if ($user_obj->category_filter() != 0) {
      $query_tail = $query_tail . sprintf(' AND l.category_id = %d',
                    $user_obj->category_filter());
   }

   // Next we decide how to order the results
   if (preg_match('/^(1|2)\z/', $user_obj->priority_sort())) {
      if ($user_obj->priority_sort() == 1) {
         $query_tail = $query_tail . ' ORDER BY p.priority';
      } else {
         $query_tail = $query_tail . ' ORDER BY p.priority DESC';
      }
      if ($user_obj->sort_stabilizer() != 'none') {
         $query_tail = $query_tail . ', ';
      }
   } else if (preg_match('/^(1|2)\z/', $user_obj->status_sort())) {
      if ($user_obj->status_sort() == 1) {
         $query_tail = $query_tail . ' ORDER BY s.status';
      } else {
         $query_tail = $query_tail . ' ORDER BY s.status DESC';
      }
      if ($user_obj->sort_stabilizer() != 'none') {
         $query_tail = $query_tail . ', ';
      }
   } else if (preg_match('/^(1|2)\z/', $user_obj->subject_sort())) {
      if ($user_obj->subject_sort() == 1) {
         $query_tail = $query_tail . ' ORDER BY l.subject';
      } else {
         $query_tail = $query_tail . ' ORDER BY l.subject DESC';
      }
      if ($user_obj->sort_stabilizer() != 'none') {
         $query_tail = $query_tail . ', ';
      }
   } else if (preg_match('/^(1|2)\z/', $user_obj->duedate_sort())) {
      if ($user_obj->duedate_sort() == 1) {
         $query_tail = $query_tail . ' ORDER BY l.due_date';
      } else {
         $query_tail = $query_tail . ' ORDER BY l.due_date DESC';
      }
      if ($user_obj->sort_stabilizer() != 'none') {
         $query_tail = $query_tail . ', ';
      }
   } else {
      if ($user_obj->sort_stabilizer() != 'none') {
         $query_tail = $query_tail . ' ORDER BY ';
      }
   }

   switch ($user_obj->sort_stabilizer()) {
      case 'none':
         break;
      case 'subject':
         $query_tail = $query_tail . 'l.subject';
         break;
      case 'lastmodified':
         $query_tail = $query_tail . 'l.last_modified';
         break;
      case 'startdate':
         $query_tail = $query_tail . 'l.start_date';
         break;
      case 'duedate':
         $query_tail = $query_tail . 'l.due_date';
         break;
      case 'createdate':
         $query_tail = $query_tail . 'l.create_date';
         break;
      case 'priority':
         $query_tail = $query_tail . 'p.priority';
         break;
      case 'status':
         $query_tail = $query_tail . 's.status';
         break;
      case 'taskid':
         $query_tail = $query_tail . 'l.id';
         break;
   }

   if (($user_obj->sort_stabilizer() != 'none')
      && ($user_obj->sort_order() == 'dsc')) {
      $query_tail = $query_tail . ' DESC';
   }

   // Put the query together before executing it
   $query = "$query_head $query_tail";

   // Get the number of rows in the result (to be used for the paginator)
   list($num_rows) = mysql_fetch_array(mysql_query($query));

   // Check for the page_num string and set appropriately
   if (isset($_REQUEST['page_num'])) {
      $page_num = $_REQUEST['page_num'];
   } else {
      $page_num = 1;
   }

   // Set up the paginator here
   $paginator = & new Paginator($page_num,$num_rows);
   $paginator->set_Limit($phpTodo_rpp);
   $paginator->set_Links(3);

   // Make sure we're on a valid page
   if ($page_num > $paginator->getTotalPages()) {
      $page_num = $paginator->getTotalPages();
      $paginator->Paginator($page_num, $num_rows);
   }

   // Get the ranges needed for mySQL
   $limit1 = $paginator->getRange1();
   $limit2 = $paginator->getRange2();

   // Now pass the info on to the smarty template
   $smarty->assign('linkNum', $paginator->getTotalPages());
   if($paginator->getPrevious()) {
      $smarty->assign('linkPrev', $paginator->getPrevious());
   }
   if($paginator->getNext()) {
      $smarty->assign('linkNext', $paginator->getNext());
   }
   $smarty->assign('linkFirst', $paginator->getFirst());
   $smarty->assign('linkLast', $paginator->getLast());
   $smarty->assign('linkArray', $paginator->getLinkArr());
   $smarty->assign('linkCur', $paginator->getCurrent());

   // Re-assign the head to actually select the data this time
   $query_head = 'SELECT l.id, p.name, l.subject, s.status, ' .
                 'DATE_FORMAT(l.due_date, "%m-%d-%Y"), ' .
                 'datediff(l.due_date, curdate()), d.nextaction ';

   // Limit the results on the screen (using the paginator limits)
   $query_tail = $query_tail . sprintf(" LIMIT %d, %d", $limit1, $limit2);

   // Put the query together before executing it
   $query = "$query_head $query_tail";

   // Execute the query
   $result = mysql_query($query) or die ( 'Error: Query: ' . mysql_error() );

   // Place the results into a two dimensional array
   $loop = 0;
   while ($line = mysql_fetch_array($result)) {
      $todolist[$loop]['id'] = $line[0];
      $todolist[$loop]['priority'] = $line[1];
      if (get_magic_quotes_gpc()) {
         $todolist[$loop]['subject'] =
            htmlentities(stripslashes(urldecode($line[2])));
         $todolist[$loop]['nextaction'] =
            htmlentities(stripslashes(urldecode($line[6])));
      } else {
         $todolist[$loop]['subject'] = htmlentities(urldecode($line[2]));
         $todolist[$loop]['nextaction'] = htmlentities(urldecode($line[6]));
      }
      $todolist[$loop]['status'] = $line[3];

      // Only display the date if it's valid
      if (isset($line[4]) && ($line[4] != '00-00-0000')) {
         $todolist[$loop]['due_date'] = $line[4];
      } else {
         $todolist[$loop]['due_date'] = '';
      }

      // Determine if the due_date is past, current, or today
      if ($line[5] < 0) {
         $todolist[$loop]['period'] = 'overdue';
      } elseif (($line[5] > 0) || is_null($line[5])) {
         $todolist[$loop]['period'] = 'current';
      } else {
         $todolist[$loop]['period'] = 'today';
      }

      $loop++;
   }

   // Assign the array to a template variable (if there is an array)
   if (! empty($todolist)) {
      $smarty->assign('todolist', $todolist);
   }

   // Free the result
   mysql_free_result($result);

   // Assign the necessary template items
   assign_priorities($smarty);
   assign_status($smarty);
   assign_categories($smarty, $user_obj);

   // Close the user object
   $user_obj->finish();

   // Close the MySQL handler
   mysql_close($sqlhdlr);

   // Display the template
   $smarty->display('todolist.tpl');
?>
