<?php
/* phpTodo - Web based todo lists                                             *}
{* Copyright (C) 2005-07  Jason Frisvold <friz@godshell.com>                  *}
{*                                                                            *}
{* This program is free software; you can redistribute it and/or modify       *}
{* it under the terms of the GNU General Public License as published by       *}
{* the Free Software Foundation; either version 2 of the License, or          *}
{* (at your option) any later version.                                        *}
{*                                                                            *}
{* This program is distributed in the hope that it will be useful,            *}
{* but WITHOUT ANY WARRANTY; without even the implied warranty of             *}
{* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *}
{* GNU General Public License for more details.                               *}
{*                                                                            *}
{* You should have received a copy of the GNU General Public License          *}
{* along with this program; if not, write to the Free Software                *}
{* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */

/* $Id: users.php,v 1.15 2007/03/06 17:58:03 xen0phage Exp $ */

   // Define phpTodo (to allow access to files)
   define('phpTodo', 1);

   // Define usesmarty (to indicate that config needs to load smarty)
   define('usesmarty', 1);

   // Load the global config
   require_once('config.php');

   // Load the paginator class
   include('libs/paginator.php');

   // Connect to the database server
   $sqlhdlr = mysql_connect($phpTodo_dbHost, $phpTodo_dbUser, $phpTodo_dbPass)
      or die( 'Error: Database Connect: ' . mysql_error() );

   // Select the database
   mysql_select_db($phpTodo_dbName)
      or die( 'Error: Choose Database: ' . mysql_error() );

   // If the user is not authenticated, jump them to the login page
   if (! $user_obj = authenticate()) {
      login_redirect();
      exit;
   }

   // Make sure this user has admin privileges
   if (! $user_obj->adminflag()) {
      // If not, redirect to the index and exit
      header('Location: index.php');
      exit;
   }

   // Check to see if this is an add or edit
   if (isset($_REQUEST['save'])) {
      if (isset($_REQUEST['add'])) {
         $user = new phpTodoUser();
      } else {
         $user = new phpTodoUser($_REQUEST['userid']);
      }
      if ($user->password($_REQUEST['password'])) {
         if ($user->fullname($_REQUEST['fullname'])) {
            if ($user->username($_REQUEST['username'])) {
               if ($user->email($_REQUEST['email'])) {
                  $user->finish();
               } else {
                  $smarty->assign('badentry', 4);
               }
            } else {
               $smarty->assign('badentry', 3);
            }
         } else {
            $smarty->assign('badentry', 2);
         }
      } else {
         $smarty->assign('badentry', 1);
      }
   // Check for an action
   } else if (isset($_REQUEST['edit'])) {
      // Create the user object
      $user = new phpTodoUser($_REQUEST['userid']);

      $smarty->assign('edit_userid', $user->user_id());
      $smarty->assign('edit_username', $user->username());
      $smarty->assign('edit_fullname', $user->fullname());
      $smarty->assign('edit_email', $user->email());
      $smarty->assign('edituser', 1);
   // Need to handle delete - also fix up password change code
   } else if (isset($_REQUEST['delete'])) {
      // Create the user object
      $user = new phpTodoUser($_REQUEST['userid']);

      $user->delete();
      $user->finish();
   }

   // Get a list of the users and assign it to the template
   $query = 'SELECT count(*) FROM users';

   // Get the number of rows in the result (to be used for the paginator)
   list($num_rows) = mysql_fetch_array(mysql_query($query));

   // Check for the page_num string and set appropriately
   if (isset($_REQUEST['page_num'])) {
      $page_num = $_REQUEST['page_num'];
   } else {
      $page_num = 1;
   }

   // Set up the paginator here
   $paginator = & new Paginator($page_num,$num_rows);
   $paginator->set_Limit($phpTodo_rpp);
   $paginator->set_Links(3);

   $limit1 = $paginator->getRange1();
   $limit2 = $paginator->getRange2();

   // Now pass the info on to the smarty template
   $smarty->assign('linkNum', $paginator->getTotalPages());

   if($paginator->getPrevious()) {
      $smarty->assign('linkPrev', $paginator->getPrevious());
   }

   if($paginator->getNext()) {
      $smarty->assign('linkNext', $paginator->getNext());
   }

   $smarty->assign('linkFirst', $paginator->getFirst());
   $smarty->assign('linkLast', $paginator->getLast());
   $smarty->assign('linkArray', $paginator->getLinkArr());
   $smarty->assign('linkCur', $paginator->getCurrent());

   // Get the data using the limits from the paginator
   $query = sprintf('SELECT id, username, full_name, email FROM users ORDER ' .
                    'BY username LIMIT %d, %d', $limit1, $limit2);

   $result = mysql_query($query) or die( 'Error: ' . mysql_error() );

   $loop = 0;
   while ($line = mysql_fetch_array($result)) {
      $userlist[$loop]['userid'] = $line[0];
      $userlist[$loop]['username'] = $line[1];
      $userlist[$loop]['fullname'] = $line[2];
      $userlist[$loop]['email'] = $line[3];
      $loop++;
   }

   $smarty->assign('userlist', $userlist);

   // Free the result
   mysql_free_result($result);

   // Close the MySQL handler
   mysql_close($sqlhdlr);

   // Display the template
   $smarty->display('users.tpl');
?>
